#include <string.h>
#include "impulse.h"

void GenerateImpulse8(unsigned char *buffer, unsigned int length)
{
	unsigned int i;
	buffer[0] = 255;
	buffer[1] = 255;
	buffer += 2;
	for(i = 0; i < length-1; i++)
	{
		buffer[0] = 128;
		buffer[1] = 128;
		buffer += 2;
	}
}

void GenerateImpulse16(signed short *buffer, unsigned int length)
{
	unsigned int i;
	buffer[0] = 32767;
	buffer[1] = 32767;
	buffer += 2;
	for(i = 0; i < length-1; i++)
	{
		buffer[0] = 0;
		buffer[1] = 0;
		buffer += 2;
	}
}

void GenerateImpulse24(Sample24 *buffer, unsigned int length)
{
	unsigned int i;
	signed long sample = 8388607;
	buffer[0].Data[0] = sample & 0xFF;
	buffer[0].Data[1] = (sample >> 8) & 0xFF;
	buffer[0].Data[2] = (sample >> 16) & 0xFF;
	buffer[1].Data[0] = sample & 0xFF;
	buffer[1].Data[1] = (sample >> 8) & 0xFF;
	buffer[1].Data[2] = (sample >> 16) & 0xFF;
	buffer += 2;
	for(i = 0; i < length-1; i++)
	{
		memset(&buffer[0], 0, sizeof(buffer[0]));
		memset(&buffer[1], 0, sizeof(buffer[1]));
		buffer += 2;
	}
}

void GenerateImpulse32(signed long *buffer, unsigned int length)
{
	unsigned int i;
	buffer[0] = 2147483647;
	buffer[1] = 2147483647;
	buffer += 2;
	for(i = 0; i < length-1; i++)
	{
		buffer[0] = 0;
		buffer[1] = 0;
		buffer += 2;
	}
}

void GenerateImpulseFloat(float *buffer, unsigned int length)
{
	unsigned int i;
	buffer[0] = 1;
	buffer[1] = 1;
	buffer += 2;
	for(i = 0; i < length-1; i++)
	{
		buffer[0] = 0;
		buffer[1] = 0;
		buffer += 2;
	}
}
