#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "EAXReverb.h"
#include "impulse.h"
#include "wav_writer.h"

int main(int argc, char *argv[])
{
	unsigned int format;
	unsigned int samplerate;
	unsigned int numseconds;
	unsigned int numsamples;
	void *samples;
	printf("Initializing.\n");
	format = 1;
	samplerate = 44100;
	numseconds = 20;
	if (argc >= 2 && argv[1])
	{
		format = atoi(argv[1]);
	}
	if (argc >= 3 && argv[2])
	{
		samplerate = atoi(argv[2]);
	}
	if (argc >= 4 && argv[3])
	{
		numseconds = atoi(argv[3]);
	}
	numsamples = samplerate * numseconds;
	if (format == 1)
	{
		samples = malloc(numsamples * 2 * sizeof(short));
	}
	else if (format == 2)
	{
		samples = malloc(numsamples * 2 * sizeof(Sample24));
	}
	else if (format == 3)
	{
		samples = malloc(numsamples * 2 * sizeof(long));
	}
	else if (format == 4)
	{
		samples = malloc(numsamples * 2 * sizeof(float));
	}
	else
	{
		samples = malloc(numsamples * 2 * sizeof(char));
	}
	for (unsigned int i = 0; i < 113; i++)
	{
		char filename[64];
		EAXReverb EAX;
		EAX.Init(samplerate);
		EAX.SetOnlyReverb(true);
		printf("%s\n", EAX.GetPresetName(i));
		EAX.SetPreset(i);
		memset(filename, 0, sizeof(filename));
		strncpy(filename, EAX.GetPresetName(i), sizeof(filename));
		strncat(filename, ".WAV", sizeof(filename));
		if (format == 1)
		{
			WavFileOpen(filename, samplerate, 16, 2, 1);
			GenerateImpulse16((short *)samples, numsamples);
			EAX.Generate16((short *)samples, numsamples);
		}
		else if (format == 2)
		{
			WavFileOpen(filename, samplerate, 24, 2, 1);
			GenerateImpulse24((Sample24 *)samples, numsamples);
			EAX.Generate24((Sample24 *)samples, numsamples);
		}
		else if (format == 3)
		{
			WavFileOpen(filename, samplerate, 32, 2, 1);
			GenerateImpulse32((long *)samples, numsamples);
			EAX.Generate32((long *)samples, numsamples);
		}
		else if (format == 4)
		{
			WavFileOpen(filename, samplerate, 32, 2, 3);
			GenerateImpulseFloat((float *)samples, numsamples);
			EAX.GenerateFloat((float *)samples, numsamples);
		}
		else
		{
			WavFileOpen(filename, samplerate, 8, 2, 1);
			GenerateImpulse8((unsigned char *)samples, numsamples);
			EAX.Generate8((unsigned char *)samples, numsamples);
		}
		WavFileWrite(samples, numsamples);
		WavFileClose();
		EAX.Close();
	}
	free(samples);
	samples = NULL;
	printf("Done.\n");
	return 0;
}
